## org.eclipse.ocl.ecore
Class EcoreEnvironment

    java.lang.Object
      org.eclipse.ocl.lpg.AbstractBasicEnvironment
          org.eclipse.ocl.AbstractEnvironment<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject>
              org.eclipse.ocl.ecore.EcoreEnvironment

All Implemented Interfaces:
  Environment<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject>, Environment.Internal<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject>, Environment.Lookup<EPackage,EClassifier,EOperation,EStructuralFeature>, BasicEnvironment, Customizable, Adaptable

Direct Known Subclasses:
  CompatibilityEnvironment

    public class EcoreEnvironment

extends AbstractEnvironment<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject>

Implementation of the `Environment` for parsing OCL expressions on Ecore models. The `EcoreEnvironment` uses a client-supplied package registry (or the global registry) to look up `EPackage`s by qualified name.

Nested Class Summary

Nested classes/interfaces inherited from class org.eclipse.ocl.AbstractEnvironment
`AbstractEnvironment.VariableEntry`

Nested classes/interfaces inherited from interface org.eclipse.ocl.Environment
`Environment.Internal<PK,C,O,P,EL,PM,S,COA,SSA,CT,CLS,E>, Environment.Lookup<PK,C,O,P>, Environment.Registry`

Field Summary

Fields inherited from interface org.eclipse.ocl.Environment
`OCL_NAMESPACE_URI, RESULT_VARIABLE_NAME, SELF_VARIABLE_NAME`

Constructor Summary
`protected` `EcoreEnvironment(Environment<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject> parent)` Initializes me with a parent environment, from which I inherit such things as a package registry and a resource.
`protected` `EcoreEnvironment(EPackage.Registry reg)` Initializes me with a package registry for package look-ups.
`protected` `EcoreEnvironment(EPackage.Registry reg, Resource resource)` Initializes me with a package registry and a resource in which I am persisted (and from which I load myself if it already has content).

Method Summary
`protected void` `collectStates(EClassifier owner, List<String> pathPrefix, List<EObject> states)` Implemented by subclasses to find all states in the specified owner type that match the given path name prefix and add them to the accumulator list.
`protected TypeResolver<EClassifier,EOperation,EStructuralFeature>` `createTypeResolver()` Deprecated. Override the `createTypeResolver(Resource)` method, instead, handling the case where the resource is `null`
`protected TypeResolver<EClassifier,EOperation,EStructuralFeature>` `createTypeResolver(Resource resource)` Creates a new type resolver for use with this environment.
`EStructuralFeature` `defineAttribute(EClassifier owner, Variable<EClassifier,EParameter> variable, Constraint constraint)` In processing an additional attribute definition, constructs the property and associates it with its definition constraint.
`EOperation` `defineOperation(EClassifier owner, String name, EClassifier type, List<Variable<EClassifier,EParameter>> params, Constraint constraint)` In processing an additional operation definition, constructs the operation and associates it with its definition constraint.
`static EPackage` `findPackage(List<String> packageNames)` Looks in the EMF registry for a package with the specified qualified package name.
`static EPackage` `findPackage(List<String> packageNames, EPackage.Registry registry)` Looks in the given registry for a package with the specified qualified package name.
`Constraint` `getDefinition(Object feature)` Obtains the definition constraint of the specified feature, if it is an additional attribute or operation defined via an OCL constraint.
`EnvironmentFactory<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject>` `getFactory()` Obtains the factory that created me, or an appropriate default factory if I was not created using a factory.
`OCLFactory` `getOCLFactory()` Obtains a factory for the creation of types that are parameterized by model elements.
`OCLStandardLibrary<EClassifier>` `getOCLStandardLibrary()` Obtains the collection of core types representing the OCL Standard Library.
`List<EObject>` `getStates(EClassifier owner, List<String> pathPrefix)` Obtains the states matching the specified path prefix in the owner type by trying the `collectStates(org.eclipse.emf.ecore.EClassifier, java.util.List<java.lang.String>, java.util.List<org.eclipse.emf.ecore.EObject>)` method on it and, recursively, its supertypes to find all matches.
`TypeResolver<EClassifier,EOperation,EStructuralFeature>` `getTypeResolver()` Obtains a type resolver to be used to create (and cache) concrete bindings for the generic OCL types, based on the user model types provided by this environment.
`UMLReflection<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint>` `getUMLReflection()` Obtains a utility for for reflection on the UML metaclasses that are used by the OCL abstract syntax.
`boolean` `isInPostcondition(OCLExpression<EClassifier> exp)` Checks whether the specified OCL expression is in an operation postcondition constraint.
`EClassifier` `lookupClassifier(List<String> names)` Finds the classifier identified by the specified sequence of names (a qualified name).
`EPackage` `lookupPackage(List<String> path)` Finds the package identified by the specified sequence of names (a qualified name). Implements the inherited specification by looking up the qualified name in my package registry.
`protected void` `setFactory(EnvironmentFactory<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject> factory)` Sets the factory that created me.
`void` `setParent(Environment<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject> env)` Sets my parent environment.
`void` `undefine(Object feature)` Removes the definition of an additional operation or property.

Methods inherited from class org.eclipse.ocl.AbstractEnvironment

`addedVariable, addElement, addHelperOperation, addHelperProperty, addOperation, addProperty, deleteElement, dispose, findNonNavigableAssociationEnds, findUnnamedAssociationEnds, getAdditionalAttributes, getAdditionalOperations, getBodyCondition, getContextClassifier, getContextOperation, getContextPackage, getContextProperty, getDeriveConstraint, getInitConstraint, getInternalParent, getParent, getResource, getSelfVariable, getVariables, initialLower, isEmpty, lookup, lookupAssociationClassReference, lookupImplicitSourceForAssociationClass, lookupImplicitSourceForOperation, lookupImplicitSourceForProperty, lookupImplicitSourceForSignal, lookupImplicitSourceForState, lookupLocal, lookupOperation, lookupProperty, lookupSignal, lookupState, notOK, removedVariable, setBodyCondition, setContextOperation, setContextPackage, setContextProperty, setDeriveConstraint, setInitConstraint, setInternalParent, setParent, setSelfVariable, tryLookupAssociationClassReference, tryLookupClassifier, tryLookupOperation, tryLookupPackage, tryLookupProperty, tryLookupSignal`

Methods inherited from class org.eclipse.ocl.lpg.AbstractBasicEnvironment

`analyzerError, analyzerError, analyzerError, analyzerWarning, basicGetOptions, clearOptions, createDefaultProblemHandler, getAdapter, getASTMapping, getASTNodeToCSTNodeMap, getFormatter, getOptions, getParser, getProblemHandler, getValue, initASTMapping, isEnabled, lexerError, parserError, problem, putOptions, removeOption, removeOptions, setASTNodeToCSTNodeMap, setOption, setParent, setParser, setProblemHandler, utilityError, validatorError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface org.eclipse.ocl.lpg.BasicEnvironment
`analyzerError, analyzerError, analyzerError, analyzerWarning, getASTMapping, getFormatter, getParser, getProblemHandler, initASTMapping, lexerError, parserError, problem, setParser, setProblemHandler, utilityError, validatorError`

Methods inherited from interface org.eclipse.ocl.util.Adaptable
`getAdapter`

Methods inherited from interface org.eclipse.ocl.options.Customizable
`clearOptions, getOptions, getValue, isEnabled, putOptions, removeOption, removeOptions, setOption`

Constructor Detail

### EcoreEnvironment

    protected EcoreEnvironment(EPackage.Registry reg)

  Initializes me with a package registry for package look-ups.

  Parameters:
    `reg` - a package registry

### EcoreEnvironment

    protected EcoreEnvironment(EPackage.Registry reg,
                               Resource resource)

  Initializes me with a package registry and a resource in which I am persisted (and from which I load myself if it already has content).

  Parameters:
    `reg` - a package registry
    `resource` - a resource, which may or may not already have content

### EcoreEnvironment

    protected EcoreEnvironment(Environment<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject> parent)

  Initializes me with a parent environment, from which I inherit such things as a package registry and a resource.

  Parameters:
    `parent` - my parent environment

Method Detail

### getFactory

    public EnvironmentFactory<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject> getFactory()

  Description copied from interface: `Environment`
  Obtains the factory that created me, or an appropriate default factory if I was not created using a factory. This factory can be used to create nested environments within me.

  Returns:
    my originating factory
  See Also:
    `EnvironmentFactory.createEnvironment(Environment)`

### setFactory

    protected void setFactory(EnvironmentFactory<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject> factory)

  Sets the factory that created me. This method should only be invoked by that factory.

  Parameters:
    `factory` - my originating factory

### setParent

    public void setParent(Environment<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint,EClass,EObject> env)

  Description copied from interface: `Environment`
  Sets my parent environment. The parent environment should not generally be set to `null` if it was not already `null`.

  Parameters:
    `env` - my new parent environment

### getOCLStandardLibrary

    public OCLStandardLibrary<EClassifier> getOCLStandardLibrary()

  Description copied from interface: `Environment`
  Obtains the collection of core types representing the OCL Standard Library. These are the singleton or generic instances of the OCL-defined classifiers such as `OclAny`, `Collection(T)`, etc. Implementers of OCL metamodel bindings are encouraged to share a single instance of the standard library amonst all of the `Environment`s constructed by a particular `EnvironmentFactory`.

  Returns:
    the OCL Standard Library implementation for this environment

### getTypeResolver

    public TypeResolver<EClassifier,EOperation,EStructuralFeature> getTypeResolver()

  Description copied from interface: `Environment`
  Obtains a type resolver to be used to create (and cache) concrete bindings for the generic OCL types, based on the user model types provided by this environment. These are the types that are parameterized by particular user model elements: collections of particular classifiers, meta-types for particular classifiers, message types for particular operations or signals, and tuple types.

  Returns:
    the type resolver

### getOCLFactory

    public OCLFactory getOCLFactory()

  Description copied from interface: `Environment`
  Obtains a factory for the creation of types that are parameterized by model elements. This type factory must create types that are instances of the metaclass describing classifiers in the client metamodel.

  Returns:
    the appropriate type factory

### getUMLReflection

    public UMLReflection<EPackage,EClassifier,EOperation,EStructuralFeature,EEnumLiteral,EParameter,EObject,CallOperationAction,SendSignalAction,Constraint> getUMLReflection()

  Description copied from interface: `Environment`
  Obtains a utility for for reflection on the UML metaclasses that are used by the OCL abstract syntax.

  Returns:
    the appropriate reflection instance

### createTypeResolver

    @Deprecated
    protected TypeResolver<EClassifier,EOperation,EStructuralFeature> createTypeResolver()

  Deprecated. Override the `createTypeResolver(Resource)` method, instead, handling the case where the resource is `null`

  Creates a new type resolver for use with this environment, persisted in a default resource.

  Returns:
    a new type resolver

### createTypeResolver

    protected TypeResolver<EClassifier,EOperation,EStructuralFeature> createTypeResolver(Resource resource)

  Creates a new type resolver for use with this environment.

  Subclasses may override.

  Parameters:
    `resource` - the resource for the type resolver's persistence
  Returns:
    a new type resolver
  Since:
    1.2

### lookupPackage

    public EPackage lookupPackage(List<String> path)

  Finds the package identified by the specified sequence of names (a qualified name).

  Implements the inherited specification by looking up the qualified name in my package registry.

  Parameters:
    `path` - the qualified name
  Returns:
    the matching package, or `null` if not found

### lookupClassifier

    public EClassifier lookupClassifier(List<String> names)

  Description copied from interface: `Environment`
  Finds the classifier identified by the specified sequence of names (a qualified name).

  Parameters:
    `names` - the qualified name
  Returns:
    the matching classifier, or `null` if not found

### getStates

    public List<EObject> getStates(EClassifier owner,
                                   List<String> pathPrefix)

  Obtains the states matching the specified path prefix in the owner type by trying the `collectStates(org.eclipse.emf.ecore.EClassifier, java.util.List<java.lang.String>, java.util.List<org.eclipse.emf.ecore.EObject>)` method on it and, recursively, its supertypes to find all matches. For implicit (`null`) owners, looks up the innermost-scoped variable as the implicit source and tries again on this variable's type.

  To extend this implementation, override the `collectStates(org.eclipse.emf.ecore.EClassifier, java.util.List<java.lang.String>, java.util.List<org.eclipse.emf.ecore.EObject>)` method.

  Parameters:
    `owner` - the classifier for which states are being sought. Can be `null` in the case of an `oclIsInState()` call on an implicit target
    `pathPrefix` - partial path name of the states being sought. This can be empty to find the first level of state names
  Returns:
    the list of all possible states directly contained in the namespace indicated by the path prefix (i.e., only one level of state nesting)

### collectStates

    protected void collectStates(EClassifier owner,
                                 List<String> pathPrefix,
                                 List<EObject> states)

  Implemented by subclasses to find all states in the specified owner type that match the given path name prefix and add them to the accumulator list. The default implementation does nothing, as Ecore does not model states.

  Implementors must only provide the states defined directly in the namespace indicated by the path prefix (i.e., only one level).

  Parameters:
    `owner` - the owner type
    `pathPrefix` - partial qualified name, specifying the parent of the states to be collection
    `states` - a list of states directly owned by the namespace indicated by path prefix, within the owner type
  See Also:
    `getStates(EClassifier, List)`

### defineAttribute

    public EStructuralFeature defineAttribute(EClassifier owner,
                                              Variable<EClassifier,EParameter> variable,
                                              Constraint constraint)

  Description copied from interface: `Environment`
  In processing an additional attribute definition, constructs the property and associates it with its definition constraint. The operation definition is local to this environment.

  Parameters:
    `owner` - the context classifier of the property definition constraint
    `variable` - the name and type of the property (conveniently encapsulated in a variable)
    `constraint` - the definition constraint
  Returns:
    the defined property

### defineOperation

    public EOperation defineOperation(EClassifier owner,
                                      String name,
                                      EClassifier type,
                                      List<Variable<EClassifier,EParameter>> params,
                                      Constraint constraint)

  Description copied from interface: `Environment`
  In processing an additional operation definition, constructs the operation and associates it with its definition constraint. The operation definition is local to this environment.

  Parameters:
    `owner` - the context classifier of the property definition constraint
    `name` - the operation name
    `params` - the names and types of the parameters, if any (conveniently encapsulated in variables)
    `constraint` - the definition constraint
  Returns:
    the defined operation

### undefine

    public void undefine(Object feature)

  Description copied from interface: `Environment`
  Removes the definition of an additional operation or property.

  Parameters:
    `feature` - an additional property or operation

### getDefinition

    public Constraint getDefinition(Object feature)

  Description copied from interface: `Environment`
  Obtains the definition constraint of the specified feature, if it is an additional attribute or operation defined via an OCL constraint.

  Parameters:
    `feature` - a property or operation
  Returns:
    the definition constraint that defines it, or `null` if this feature is not defined by OCL

### findPackage

    public static EPackage findPackage(List<String> packageNames)

  Looks in the EMF registry for a package with the specified qualified package name. Uses the global package registry.

  Parameters:
    `packageNames` - the qualified package name
  Returns:
    the matching EPackage, or `null` if not found

### findPackage

    public static EPackage findPackage(List<String> packageNames,
                                       EPackage.Registry registry)

  Looks in the given registry for a package with the specified qualified package name.

  Parameters:
    `packageNames` - the qualified package name
    `registry` - the EPackage.Registry to look in
  Returns:
    the matching EPackage, or `null` if not found

### isInPostcondition

    public boolean isInPostcondition(OCLExpression<EClassifier> exp)

  Description copied from interface: `Environment`
  Checks whether the specified OCL expression is in an operation postcondition constraint. This is used in validating the usage of constructs that are only valid in postconditions (e.g., `oclIsNew()`).

  Parameters:
    `exp` - an OCL expression
  Returns:
    `true` if it is in a postcondition constraint; `false`, otherwise (including case of no constraint at all)

Copyright 2002, 2007 IBM Corporation and others. All Rights Reserved.